<?php

if ($_POST['secretkey'] != 'jfs839howis39fso3ihdfs'){
    echo 'no key';
    exit();
}

require_once "sleekdb/SleekDB.php";

$databaseDirectory = __DIR__ . "/db";

$currentstore = new \SleekDB\Store("power_data", $databaseDirectory);

$timestamp = date("Y-m-d-H-i-s");
$date = date("Y-m-d");
$month = date("Y-m");
$time = date("H.i");
$datetoday = date("Y-m-d");

if ($_POST['Total_in']){

$Power_cur = $_POST['Power_cur'];
$Total_in = $_POST['Total_in']; 
$Total_out = $_POST['Total_out']; 
$p = $_POST['p'];
$e = $_POST['e'];
$te = $_POST['te'];

$data = $currentstore->findBy(["date", "=", $datetoday ],["_id" => "desc"]);
$currentid = $data[0]["_id"];
$count = count($data);

$item = [
    'date' => $date,
    $timestamp => [
        'month' => $month, 
        'date' => $date,
        'timestamp' => $timestamp, 
        'time' => $time, 
        'Power_cur' => $Power_cur,  
        'Total_in' => $Total_in,
        'Total_out' => $Total_out,
        'p' => $p,  
        'e' => $e,
        'te' => $te
    ],
];

if ($count > 0){
    $currentstore->updateById($currentid, $item);
} else {
    $results = $currentstore->insert($item);
}

}
    
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// TAGESSUMME

$currentstore = new \SleekDB\Store("power_data", $databaseDirectory);

$data = $currentstore->findBy(["date", "=", $datetoday],["_id" => "asc"]);
$data = $data[0];

$minTotalIn = 0;
$maxTotalIn = 0;

$minTotalTe = 0;
$maxTotalTe = 0;

$minTotalOut = 0;
$maxTotalOut = 0;


$total_sun_day = 0;

foreach ($data as $key => $value) {
    
    if (isset($value["Total_in"]) && $value["Total_in"] > 0) {
        $totalIn = $value["Total_in"];
        if ($minTotalIn == 0 || $totalIn < $minTotalIn) {
            $minTotalIn = $totalIn;
        }
        if ($totalIn > $maxTotalIn) {
            $maxTotalIn = $totalIn;
        }
    }

    if (isset($value["te"]) && $value["te"] > 0) {
        $totalTe = $value["te"];
        if ($minTotalTe == 0 || $totalTe < $minTotalTe) {
            $minTotalTe = $totalTe;
        }
        if ($totalTe > $maxTotalTe) {
            $maxTotalTe = $totalTe;
        }
    }

    if (isset($value["Total_out"]) && $value["Total_out"] > 0) {
        $totalOut = $value["Total_out"];
        if ($minTotalOut == 0 || $totalOut < $minTotalOut) {
            $minTotalOut = $totalOut;
        }
        if ($totalOut > $maxTotalOut) {
            $maxTotalOut = $totalOut;
        }
    }
}

$total_sun_day = $maxTotalTe - $minTotalTe;
$total_in_day = $maxTotalIn - $minTotalIn;
$total_out_day = $maxTotalOut - $minTotalOut;

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*
$total_sun_month = 0;
$total_in_month = 0;
*/

// TAGESSUMME EINTRAGEN

$currentstore = new \SleekDB\Store("power_data_daily", $databaseDirectory);

$data = $currentstore->findBy(["month", "=", $month ], ["_id" => "asc"], 1);
$count = count($data);

$currentid = $data[0]["_id"];

/*
$date = "2024-01-13";
$total_sun_day = 0.048000000000000001;
$total_in_day = 4.633;
*/

$item = [ 
    $date => [
        'month' => $month, 
        'date' => $date,
        "total_sun_day" => $total_sun_day,
        "total_in_day" => $total_in_day,
        "total_out_day" => $total_out_day
    ],
    'month' => $month,
    "total_sun_month" => $total_sun_month,
    "total_in_month" => $total_in_month,
    "total_out_month" => $total_out_month
];

if ($count > 0){
    $currentstore->updateById($currentid, $item);
} else {
    $results = $currentstore->insert($item);
}

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

// MONATSSUMME VERBRAUCH

$currentstore = new \SleekDB\Store("power_data_daily", $databaseDirectory);

$data = $currentstore->findBy(["month", "=", $month], ["_id" => "asc"]);

$gesamtSunMonth = 0;
$gesamtInMonth = 0;
$gesamtOutMonth = 0;

foreach ($data as $item) {
    $gesamtSunMonth += $item['total_sun_month'];
    $gesamtInMonth += $item['total_in_month'];
    $gesamtOutMonth += $item['total_out_month'];

    foreach ($item as $key => $value) {
        if (is_array($value) && array_key_exists('total_sun_day', $value)) {
            $gesamtSunMonth += $value['total_sun_day'];
            $gesamtInMonth += $value['total_in_day'];
            $gesamtOutMonth += $value['total_out_day'];
        }
    }
}

// MONATSSUMME EINTRAGEN

$currentstore = new \SleekDB\Store("power_data_daily", $databaseDirectory);

$data = $currentstore->findBy(["month", "=", $month ], ["_id" => "asc"], 1);
$count = count($data);

$item = [
    'month' => $month,
    "total_sun_month" => $gesamtSunMonth,
    "total_in_month" => $gesamtInMonth,
    "total_out_month" => $gesamtOutMonth
];

if ($count == 1){

$currentid = $data[0]["_id"];

$currentstore->updateById($currentid, $item);

} else {

    $currentstore->insert($item);

}

?>