<?php 

setlocale(LC_TIME, 'de_DE.utf8');

$selected_day = date("Y-m-d");

require_once "sleekdb/SleekDB.php";

$databaseDirectory = __DIR__ . "/db";

$date_today = date("Y-m-d");
$monthtoday = date("Y-m");

$power_data_store = new \SleekDB\Store("power_data", $databaseDirectory);
$data = $power_data_store->findBy(["date", "=", $date_today],["_id" => "desc"]);

if (end($data[0])["p"]){ $p = end($data[0])["p"]; } else { $p = 0; }

$currentstore = new \SleekDB\Store("power_data_daily", $databaseDirectory);
$month_data = $currentstore->findBy(["month", "=", $monthtoday],["_id" => "desc"],1);

$total_sun_day = number_format($month_data[0][$selected_day]['total_sun_day'], 2);

echo '{"now":'.$p.',"total_sun_day":'.$total_sun_day.'}';

